/**
 * generated by Xtext 2.16.0
 */
package org.protelis.parser.scoping;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.function.Consumer;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.common.types.JvmDeclaredType;
import org.eclipse.xtext.common.types.JvmFeature;
import org.eclipse.xtext.common.types.JvmField;
import org.eclipse.xtext.common.types.JvmOperation;
import org.eclipse.xtext.common.types.JvmVisibility;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.resource.EObjectDescription;
import org.eclipse.xtext.resource.IEObjectDescription;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.Scopes;
import org.eclipse.xtext.scoping.impl.MapBasedScope;
import org.eclipse.xtext.scoping.impl.SimpleScope;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.protelis.parser.protelis.Block;
import org.protelis.parser.protelis.Call;
import org.protelis.parser.protelis.FunctionDef;
import org.protelis.parser.protelis.ImportDeclaration;
import org.protelis.parser.protelis.ImportSection;
import org.protelis.parser.protelis.JavaImport;
import org.protelis.parser.protelis.Lambda;
import org.protelis.parser.protelis.ProtelisImport;
import org.protelis.parser.protelis.ProtelisModule;
import org.protelis.parser.protelis.Rep;
import org.protelis.parser.protelis.Share;
import org.protelis.parser.protelis.ShareInitialize;
import org.protelis.parser.protelis.Statement;
import org.protelis.parser.protelis.VarDef;
import org.protelis.parser.protelis.VarDefList;
import org.protelis.parser.protelis.VarUse;
import org.protelis.parser.protelis.Yield;
import org.protelis.parser.scoping.AbstractProtelisScopeProvider;

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
@SuppressWarnings("all")
public class ProtelisScopeProvider extends AbstractProtelisScopeProvider {
  @Override
  public IScope getScope(final EObject context, final EReference reference) {
    IScope _xifexpression = null;
    if ((context instanceof VarUse)) {
      _xifexpression = this.scope_VarUse_reference(((VarUse)context), reference);
    } else {
      IScope _xifexpression_1 = null;
      if ((context instanceof Call)) {
        IScope _xblockexpression = null;
        {
          EObject global = ((Call)context).eContainer();
          while ((!(global instanceof ProtelisModule))) {
            global = global.eContainer();
          }
          _xblockexpression = this.scope_Call_reference(((ProtelisModule) global), reference);
        }
        _xifexpression_1 = _xblockexpression;
      } else {
        _xifexpression_1 = super.getScope(context, reference);
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
  
  private Iterable<VarDef> extractReferences(final EObject container) {
    Iterable<VarDef> _switchResult = null;
    boolean _matched = false;
    if (container instanceof Block) {
      _matched=true;
      List<VarDef> _xifexpression = null;
      Statement _first = ((Block)container).getFirst();
      if ((_first instanceof VarDef)) {
        Statement _first_1 = ((Block)container).getFirst();
        _xifexpression = Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList(((VarDef) _first_1)));
      } else {
        _xifexpression = CollectionLiterals.<VarDef>emptyList();
      }
      _switchResult = _xifexpression;
    }
    if (!_matched) {
      if (container instanceof FunctionDef) {
        _matched=true;
        List<VarDef> _elvis = null;
        VarDefList _args = ((FunctionDef)container).getArgs();
        EList<VarDef> _args_1 = null;
        if (_args!=null) {
          _args_1=_args.getArgs();
        }
        if (_args_1 != null) {
          _elvis = _args_1;
        } else {
          List<VarDef> _emptyList = CollectionLiterals.<VarDef>emptyList();
          _elvis = _emptyList;
        }
        _switchResult = _elvis;
      }
    }
    if (!_matched) {
      if (container instanceof Lambda) {
        _matched=true;
        List<VarDef> _xblockexpression = null;
        {
          final EObject lambdaArgs = ((Lambda)container).getArgs();
          List<VarDef> _switchResult_1 = null;
          boolean _matched_1 = false;
          if (lambdaArgs instanceof VarDef) {
            _matched_1=true;
            _switchResult_1 = Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList(((VarDef)lambdaArgs)));
          }
          if (!_matched_1) {
            if (lambdaArgs instanceof VarDefList) {
              _matched_1=true;
              _switchResult_1 = ((VarDefList)lambdaArgs).getArgs();
            }
          }
          if (!_matched_1) {
            _switchResult_1 = CollectionLiterals.<VarDef>emptyList();
          }
          _xblockexpression = _switchResult_1;
        }
        _switchResult = _xblockexpression;
      }
    }
    if (!_matched) {
      if (container instanceof Rep) {
        _matched=true;
        VarDef _x = ((Rep)container).getInit().getX();
        _switchResult = Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList(_x));
      }
    }
    if (!_matched) {
      if (container instanceof Share) {
        _matched=true;
        Iterable<VarDef> _xblockexpression = null;
        {
          final ShareInitialize init = ((Share)container).getInit();
          VarDef _field = ((Share)container).getInit().getField();
          List<VarDef> _xifexpression = null;
          VarDef _local = init.getLocal();
          boolean _tripleEquals = (_local == null);
          if (_tripleEquals) {
            _xifexpression = Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList());
          } else {
            VarDef _local_1 = init.getLocal();
            _xifexpression = Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList(_local_1));
          }
          _xblockexpression = Iterables.<VarDef>concat(Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList(_field)), _xifexpression);
        }
        _switchResult = _xblockexpression;
      }
    }
    if (!_matched) {
      if (container instanceof VarDef) {
        _matched=true;
        _switchResult = Collections.<VarDef>unmodifiableList(CollectionLiterals.<VarDef>newArrayList(((VarDef)container)));
      }
    }
    if (!_matched) {
      if (container instanceof Yield) {
        _matched=true;
        ArrayList<VarDef> _xblockexpression = null;
        {
          final EObject parent = ((Yield)container).eContainer();
          Block _switchResult_1 = null;
          boolean _matched_1 = false;
          if (parent instanceof Rep) {
            _matched_1=true;
            _switchResult_1 = ((Rep)parent).getBody();
          }
          if (!_matched_1) {
            if (parent instanceof Share) {
              _matched_1=true;
              _switchResult_1 = ((Share)parent).getBody();
            }
          }
          Block body = _switchResult_1;
          final ArrayList<VarDef> result = new ArrayList<VarDef>();
          while ((body != null)) {
            {
              Iterables.<VarDef>addAll(result, this.extractReferences(body));
              body = body.getOthers();
            }
          }
          _xblockexpression = result;
        }
        _switchResult = _xblockexpression;
      }
    }
    if (!_matched) {
      _switchResult = CollectionLiterals.<VarDef>emptyList();
    }
    return _switchResult;
  }
  
  public IScope scope_VarUse_reference(final VarUse expression, final EReference ref) {
    IScope _xblockexpression = null;
    {
      final ArrayList<VarDef> list = new ArrayList<VarDef>();
      EObject container = expression.eContainer();
      while ((container != null)) {
        {
          boolean _matched = false;
          if (container instanceof ProtelisModule) {
            _matched=true;
            return MapBasedScope.createScope(this.scope_Call_reference(((ProtelisModule)container), ref), Scopes.scopeFor(list).getAllElements());
          }
          Iterables.<VarDef>addAll(list, this.extractReferences(container));
          container = container.eContainer();
        }
      }
      _xblockexpression = Scopes.scopeFor(Collections.<EObject>emptyList());
    }
    return _xblockexpression;
  }
  
  public IScope scope_Call_reference(final ProtelisModule model, final EReference ref) {
    IScope _xblockexpression = null;
    {
      EList<FunctionDef> _definitions = model.getDefinitions();
      final List<EObject> internal = new ArrayList<EObject>(_definitions);
      final List<IEObjectDescription> externalProtelis = new ArrayList<IEObjectDescription>();
      final List<IEObjectDescription> executables = new ArrayList<IEObjectDescription>();
      ImportSection _imports = null;
      if (model!=null) {
        _imports=model.getImports();
      }
      EList<ImportDeclaration> _importDeclarations = null;
      if (_imports!=null) {
        _importDeclarations=_imports.getImportDeclarations();
      }
      if (_importDeclarations!=null) {
        final Consumer<ImportDeclaration> _function = (ImportDeclaration import_) -> {
          if ((import_ instanceof ProtelisImport)) {
            final String moduleName = ((ProtelisImport)import_).getModule().getName();
            final Function1<FunctionDef, Boolean> _function_1 = (FunctionDef it) -> {
              return Boolean.valueOf(it.isPublic());
            };
            final Consumer<FunctionDef> _function_2 = (FunctionDef it) -> {
              externalProtelis.add(ProtelisScopeProvider.generateDescription(it.getName(), it));
              String _name = it.getName();
              String _plus = ((moduleName + ":") + _name);
              externalProtelis.add(ProtelisScopeProvider.generateDescription(_plus, it));
            };
            IterableExtensions.<FunctionDef>filter(((ProtelisImport)import_).getModule().getDefinitions(), _function_1).forEach(_function_2);
          } else {
            if ((import_ instanceof JavaImport)) {
              final JvmDeclaredType type = ((JavaImport)import_).getImportedType();
              final Function1<EObject, Boolean> _function_3 = (EObject it) -> {
                return Boolean.valueOf(((it instanceof JvmField) || (it instanceof JvmOperation)));
              };
              final Function1<EObject, JvmFeature> _function_4 = (EObject it) -> {
                return ((JvmFeature) it);
              };
              final Function1<JvmFeature, Boolean> _function_5 = (JvmFeature it) -> {
                return Boolean.valueOf(it.isStatic());
              };
              final Function1<JvmFeature, Boolean> _function_6 = (JvmFeature it) -> {
                JvmVisibility _visibility = it.getVisibility();
                return Boolean.valueOf(Objects.equal(_visibility, JvmVisibility.PUBLIC));
              };
              final Function1<JvmFeature, Boolean> _function_7 = (JvmFeature it) -> {
                return Boolean.valueOf((((JavaImport)import_).isWildcard() || Objects.equal(it.getSimpleName(), ((JavaImport)import_).getImportedMemberName())));
              };
              ProtelisScopeProvider.populateMethodReferences(IterableExtensions.<JvmFeature>filter(IterableExtensions.<JvmFeature>filter(IterableExtensions.<JvmFeature>filter(IterableExtensions.<EObject, JvmFeature>map(IterableExtensions.<EObject>filter(type.eContents(), _function_3), _function_4), _function_5), _function_6), _function_7), executables);
            }
          }
        };
        _importDeclarations.forEach(_function);
      }
      final IScope plainProtelis = Scopes.scopeFor(internal);
      final SimpleScope refJava = new SimpleScope(executables);
      final IScope outer = MapBasedScope.createScope(refJava, externalProtelis);
      final IScope final_ = MapBasedScope.createScope(outer, plainProtelis.getAllElements());
      _xblockexpression = final_;
    }
    return _xblockexpression;
  }
  
  public static void populateMethodReferences(final Iterable<JvmFeature> source, final Collection<IEObjectDescription> destination) {
    final Consumer<JvmFeature> _function = (JvmFeature it) -> {
      destination.add(ProtelisScopeProvider.generateDescription(it.getSimpleName(), it));
      destination.add(ProtelisScopeProvider.generateDescription(it.getQualifiedName().replace(".", "::"), it));
    };
    source.forEach(_function);
  }
  
  public static IEObjectDescription generateDescription(final String name, final EObject obj) {
    IEObjectDescription _xblockexpression = null;
    {
      final QualifiedName ref = QualifiedName.create(name);
      _xblockexpression = EObjectDescription.create(ref, obj);
    }
    return _xblockexpression;
  }
}
